<link rel="import" href="bower_components/polymer/polymer.html">
<link rel="import" href="bower_components/iron-flex-layout/iron-flex-layout.html">
<link rel="import" href="bower_components/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="bower_components/d2l-text-input/d2l-text-input.html">
<link rel="import" href="bower_components/paper-button/paper-button.html">
<link rel="import" href="bower_components/iron-form/iron-form.html">

<dom-module id="tiny-book-form">
    <template>
        <tiny-pouchdb name="tiny-books" books="{{elements}}" id="db"></tiny-pouchdb>

        <style include="iron-flex iron-flex-layout"></style>

            <iron-form id="my-form">
                <form method="post">
                    <input type="hidden" name="_id" value="{{book._id}}"/>
                    <input type="hidden" name="img_content_type" value="{{book.img.content_type}}"/>
                    <input type="hidden" name="img_filename" value="{{book.img.filename}}"/>
                    <input type="hidden" name="img_data" value="{{book.img.data}}"/>
                    <input type="hidden" name="img_path" value="{{book.img.path}}"/>
                    <d2l-text-input name="title" value="{{book.title}}"></d2l-text-input>
                    <d2l-text-input name="author" value="{{book.author}}"></d2l-text-input>
                    <d2l-text-input name="price" value="{{book.price}}"></d2l-text-input>
                    <d2l-text-input name="url" value="{{book.url}}"></d2l-text-input>
                    <paper-button on-click="connectedCallback" style="background-color: orange;">Modifier</paper-button>
                </form>
            </iron-form>

    </template>

    <script>
    class TinyBookForm extends Polymer.Element {
        static get is() {
            return "tiny-book-form";
        }

        static get properties() {
            return {
                book: {
                    type: Object,
                    notify: true
                }
            }
        }

        connectedCallback() {
            super.connectedCallback();
            const form = this.$['my-form'];
            form.submit();
            form.addEventListener('iron-form-presubmit', function (event) {
              event.preventDefault();
              let res = form.serializeForm();
              const db = new PouchDB("http://localhost:5984/books");
              db.get(res['_id']).then(function(doc) {
                return db.put({
                    _id: res['_id'],
                    _rev: doc._rev,
                    title: res['title'],
                    author: res['author'],
                    price: res['price'],
                    url: res['url'],
                    img: {
                        content_type: res['img_content_type'],
                        filename: res['img_filename'],
                        data: res['img_data'],
                        path: res['img_path']
                    }
                })
              }).then(function() {
                window.location.reload();
              }).catch(function(err) {
                console.log(err);
              });
            });
        }
    }
    customElements.define(TinyBookForm.is, TinyBookForm);
    </script>
</dom-module>
